class KBPMultipoles:
    neighs = dict()

    def __init__(self):
        neighM4 = ((4,),
                   (5,),
                   (6,),
                   (7,),
                   (0,5,7),
                   (1,4,6),
                   (2,5,7),
                   (3,4,6))
        self.neighs["M4"] = neighM4
        
        neighM44 = ((4,),
                    (5,),
                    (7,),
                    (8,),
                    (0,5,9),
                    (1,4,6),
                    (5,7,9),
                    (2,6,8),
                    (3,7,9),
                    (4,6,8))
        self.neighs["M44"] = neighM44

        neighM44R = ((4,),
                     (5,),
                     (5,),
                     (4,),
                     (0,3,5),
                     (1,2,4))
        self.neighs["M44R"] = neighM44R

        neighM46 = ((6,),
                    (8,),
                    (9,),
                    (11,),
                    (12,),
                    (13,),
                    (0,7,13),
                    (6,8,10),
                    (1,7,9),
                    (2,8,10),
                    (7,9,11),
                    (3,10,12),
                    (4,11,13),
                    (5,6,12))
        self.neighs["M46"] = neighM46

        neighM66 = ((8,),
                    (9,),
                    (10,),
                    (11,),
                    (13,),
                    (14,),
                    (15,),
                    (16,),
                    (0,9,17),
                    (1,8,10),
                    (2,9,11),
                    (3,10,12),
                    (11,13,17),
                    (4,12,14),
                    (5,13,15),
                    (6,14,16),
                    (7,15,17),
                    (8,12,16))
        self.neighs["M66"] = neighM66

        neighM48 = ((8,),
                    (10,),
                    (11,),
                    (13,),
                    (14,),
                    (15,),
                    (16,),
                    (17,),
                    (0,9,17),
                    (8,10,12),
                    (1,9,11),
                    (2,10,12),
                    (9,11,13),
                    (3,12,14),
                    (4,13,15),
                    (5,14,16),
                    (6,15,17),
                    (7,8,16))
        self.neighs["M48"] = neighM48

        neighM68 = ((10,),
                    (11,),
                    (12,),
                    (13,),
                    (15,),
                    (16,),
                    (17,),
                    (18,),
                    (19,),
                    (20,),
                    (0,11,21),
                    (1,10,12),
                    (2,11,13),
                    (3,12,14),
                    (13,15,21),
                    (4,14,16),
                    (5,15,17),
                    (6,16,18),
                    (7,17,19),
                    (8,18,20),
                    (9,19,21),
                    (10,14,20))
        self.neighs["M68"] = neighM68

        neighM88 = ((12,),
                    (13,),
                    (14,),
                    (15,),
                    (16,),
                    (17,),
                    (19,),
                    (20,),
                    (21,),
                    (22,),
                    (23,),
                    (24,),
                    (0,13,25),
                    (1,12,14),
                    (2,13,15),
                    (3,14,16),
                    (4,15,17),
                    (5,16,18),
                    (17,19,25),
                    (6,18,20),
                    (7,19,21),
                    (8,20,22),
                    (9,21,23),
                    (10,22,24),
                    (11,23,25),
                    (12,18,24))
        self.neighs["M88"] = neighM88

        neighM444 = ((3,),
                     (5,),
                     (7,),
                     (0,4,8),
                     (3,5,9),
                     (1,4,6),
                     (5,7,9),
                     (2,6,8),
                     (3,7,9),
                     (4,6,8))
        self.neighs["M444"] = neighM444

        neighM444R = ((3,),
                      (3,),
                      (3,),
                      (0,1,2))
        self.neighs["M444R"] = neighM444R
        
        neighM4664 = ((6,),
                      (8,),
                      (10,),
                      (11,),
                      (13,),
                      (15,),
                      (0,7,15),
                      (6,8,16),
                      (1,7,9),
                      (8,10,16),
                      (2,9,11),
                      (3,10,12),
                      (11,13,17),
                      (4,12,14),
                      (13,15,17),
                      (5,6,14),
                      (7,9,17),
                      (12,14,16))
        self.neighs["M4664"] = neighM4664

        neighM4664R = ((8,),
                       (6,),
                       (6,),
                       (7,),
                       (9,),
                       (9,),
                       (1,2,7),
                       (3,6,8),
                       (0,7,9),
                       (4,5,8))
        self.neighs["M4664R"] = neighM4664R
        
        neighM4446 = ((6,),
                      (9,),
                      (10,),
                      (13,),
                      (14,),
                      (17,),
                      (0,7,17),
                      (6,8,16),
                      (7,9,11),
                      (1,8,10),
                      (2,9,11),
                      (8,10,12),
                      (11,13,15),
                      (3,12,14),
                      (4,13,15),
                      (12,14,16),
                      (7,15,17),
                      (5,6,16))
        self.neighs["M4446"] = neighM4446

        neighM44448 = ((8,),
                       (9,),
                       (12,),
                       (13,),
                       (16,),
                       (17,),
                       (20,),
                       (21,),
                       (0,9,23),
                       (1,8,10),
                       (9,11,23),
                       (10,12,14),
                       (2,11,13),
                       (3,12,14),
                       (11,13,15),
                       (14,16,18),
                       (4,15,17),
                       (5,16,18),
                       (15,17,19),
                       (18,20,22),
                       (6,19,21),
                       (7,20,22),
                       (19,21,23),
                       (8,10,22))
        self.neighs["M44448"] = neighM44448

        neighM46664 = ((7,),
                       (9,),
                       (11,),
                       (13,),
                       (15,),
                       (16,),
                       (18,),
                       (0,8,18),
                       (7,9,21),
                       (1,8,10),
                       (9,11,21),
                       (2,10,12),
                       (11,13,19),
                       (3,12,14),
                       (13,15,19),
                       (4,14,16),
                       (5,15,17),
                       (16,18,20),
                       (6,7,17),
                       (12,14,20),
                       (17,19,21),
                       (8,10,20))
        self.neighs["M46664"] = neighM46664

        neighM46664R = ((6,),
                        (7,),
                        (7,),
                        (7,),
                        (5,),
                        (4,),
                        (0,),
                        (1,2,3))
        self.neighs["M46664R"] = neighM46664R

        neighM46464 = ((7,),
                       (9,),
                       (11,),
                       (14,),
                       (15,),
                       (17,),
                       (20,),
                       (0,8,20),
                       (7,9,19),
                       (1,8,10),
                       (9,11,21),
                       (2,10,12),
                       (11,13,21),
                       (12,14,16),
                       (3,13,15),
                       (4,14,16),
                       (13,15,17),
                       (5,16,18),
                       (17,19,21),
                       (8,18,20),
                       (6,7,19),
                       (10,12,18))
        self.neighs["M46464"] = neighM46464

        neighM46464R = ((6,),
                        (7,),
                        (7,),
                        (4,),
                        (3,),
                        (7,),
                        (0,),
                        (1,2,5))
        self.neighs["M46464R"] = neighM46464R

        neighM464646 = ((6,),
                        (8,),
                        (10,),
                        (12,),
                        (14,),
                        (16,),
                        (0,7,17),
                        (6,8,18),
                        (1,7,9),
                        (8,10,19),
                        (2,9,11),
                        (10,12,19),
                        (3,11,13),
                        (12,14,20),
                        (4,13,15),
                        (14,16,20),
                        (5,15,17),
                        (6,16,18),
                        (7,17,21),
                        (9,11,21),
                        (13,15,21),
                        (18,19,20))
        self.neighs["M464646"] = neighM464646

        neighM464646R = ((6,),
                         (6,),
                         (7,),
                         (7,),
                         (8,),
                         (8,),
                         (0,1,9),
                         (2,3,9),
                         (4,5,9),
                         (6,7,8))
        self.neighs["M464646R"] = neighM464646R

        neighM464646R2 = ((6,),
                          (6,),
                          (7,),
                          (7,),
                          (7,),
                          (6,),
                          (0,1,5),
                          (2,3,4))
        self.neighs["M464646R2"] = neighM464646R2

        neighM46464646 = ((6,),
                          (9,),
                          (11,),
                          (13,),
                          (16,),
                          (18,),
                          (0,7,19),
                          (6,8,20),
                          (7,9,21),
                          (1,8,10),
                          (9,11,21),
                          (2,10,12),
                          (11,13,22),
                          (3,12,14),
                          (13,15,22),
                          (14,16,23),
                          (4,15,17),
                          (16,18,23),
                          (5,17,19),
                          (6,18,20),
                          (7,19,25),
                          (8,10,24),
                          (12,14,24),
                          (15,17,25),
                          (21,22,25),
                          (20,23,24))
        self.neighs["M46464646"] = neighM46464646

        neighM46464646R = ((6,),
                           (7,),
                           (7,),
                           (8,),
                           (9,),
                           (9,),
                           (0,7,8),
                           (1,2,6),
                           (3,6,9),
                           (4,5,8))
        self.neighs["M46464646R"] = neighM46464646R

        neighSimple = ((1,),
                       (0,),
                       (3,),
                       (2,))
        self.neighs["Simple"] = neighSimple

        neighTriangle = ((3,),
                         (4,),
                         (5,),
                         (0,4,5),
                         (1,3,5),
                         (2,3,4))
        self.neighs["Triangle"] = neighTriangle

        neighPentagon = ((5,),
                         (6,),
                         (7,),
                         (8,),
                         (9,),
                         (0,6,9),
                         (1,5,7),
                         (2,6,8),
                         (3,7,9),
                         (4,5,8))
        self.neighs["Pentagon"] = neighPentagon

        neighHexagon = ((6,),
                        (7,),
                        (8,),
                        (9,),
                        (10,),
                        (11,),
                        (0,7,11),
                        (1,6,8),
                        (2,7,9),
                        (3,8,10),
                        (4,9,11),
                        (5,6,10))
        self.neighs["Hexagon"] = neighHexagon
        
        neighOctagon = ((8,),
                        (9,),
                        (10,),
                        (11,),
                        (12,),
                        (13,),
                        (14,),
                        (15,),
                        (0,9,15),
                        (1,8,10),
                        (2,9,11),
                        (3,10,12),
                        (4,11,13),
                        (5,12,14),
                        (6,13,15),
                        (7,8,14))
        self.neighs["Octagon"] = neighOctagon

        neighLuD = ((8,),
                    (9,),
                    (22,),
                    (24,),
                    (25,),
                    (21,),
                    (17,),
                    (16,),
                    (0,9,10),
                    (1,8,13),
                    (8,11,14),
                    (10,12,15),
                    (11,13,23),
                    (9,12,22),
                    (10,15,16),
                    (11,14,18),
                    (7,14,17),
                    (6,16,19),
                    (15,19,20),
                    (17,18,21),
                    (18,21,25),
                    (5,19,20),
                    (2,13,23),
                    (12,22,24),
                    (3,23,25),
                    (4,20,24))
        self.neighs["LuD"] = neighLuD
        
        neighLuE = ((8,),
                    (12,),
                    (13,),
                    (16,),
                    (19,),
                    (22,),
                    (23,),
                    (26,),
                    (0,9,11),
                    (8,10,12),
                    (9,11,15),
                    (8,10,27),
                    (1,9,13),
                    (2,12,14),
                    (13,15,16),
                    (10,14,17),
                    (3,14,17),
                    (15,16,18),
                    (17,19,21),
                    (4,18,20),
                    (19,21,22),
                    (18,20,25),
                    (5,20,23),
                    (6,22,24),
                    (23,25,26),
                    (21,24,27),
                    (7,24,27),
                    (11,25,26))
        self.neighs["LuE"] = neighLuE
        
        neighLuF = ((9,),
                    (15,),
                    (17,),
                    (18,),
                    (23,),
                    (24,),
                    (25,),
                    (29,),
                    (31,),
                    (0,10,14),
                    (9,11,15),
                    (10,12,16),
                    (11,13,21),
                    (12,14,28),
                    (9,13,31),
                    (1,10,16),
                    (11,15,17),
                    (2,16,18),
                    (3,17,19),
                    (18,20,23),
                    (19,21,22),
                    (12,20,28),
                    (20,23,24),
                    (4,19,22),
                    (5,22,25),
                    (6,24,26),
                    (25,27,29),
                    (26,28,30),
                    (13,21,27),
                    (7,26,30),
                    (27,29,31),
                    (8,14,30))
        self.neighs["LuF"] = neighLuF

        neighLuG = ((10,),
                    (14,),
                    (15,),
                    (18,),
                    (21,),
                    (24,),
                    (25,),
                    (30,),
                    (32,),
                    (33,),
                    (0,11,13),
                    (10,12,14),
                    (11,13,17),
                    (10,12,35),
                    (1,11,15),
                    (2,14,16),
                    (15,17,18),
                    (12,16,19),
                    (3,16,19),
                    (17,18,20),
                    (19,21,23),
                    (4,20,22),
                    (21,23,24),
                    (20,22,29),
                    (5,22,25),
                    (6,24,26),
                    (25,27,30),
                    (26,28,31),
                    (27,29,34),
                    (23,28,35),
                    (7,26,31),
                    (27,30,32),
                    (8,31,33),
                    (9,32,34),
                    (28,33,35),
                    (13,29,34))
        self.neighs["LuG"] = neighLuG
